"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BusyIndicator = void 0;
const state_switch_js_1 = require("./state-switch.js");
class BusyIndicator {
    state;
    constructor(...args) {
        this.state = new state_switch_js_1.StateSwitch(...args);
    }
    busy(b) {
        if (typeof b === 'undefined') {
            return !!(this.state.active());
        }
        if (b) {
            this.state.active(true);
        }
        else {
            this.state.inactive(true);
        }
    }
    /**
     * Return a Promise that resolves when the busy state is off
     */
    async idle() {
        await this.state.stable('inactive');
    }
    /**
     * @deprecated use idle() instead
     */
    async available() {
        console.error('available() is deprecated, use idle() instead.\n' + new Error().stack);
        return this.idle();
    }
}
exports.BusyIndicator = BusyIndicator;
//# sourceMappingURL=busy-indicator.js.map